<?php
/**
*
* @package   davical
* @category Technical
* @subpackage   ldap
* @author    Eric Seigne <eric.seigne@ryxeo.com>,
*            Andrew McMillan <andrew@mcmillan.net.nz>
* @copyright Eric Seigne
* @license   http://gnu.org/copyleft/gpl.html GNU GPL v2 or later
*/

require_once("auth-functions.php");

class synoPamDrivers
{
  /**#@+
  * @access private
  */

  /**#@-*/


  /**
  * The constructor
  *
  */
  function __construct($config) {
      global $c;
  }
}


/**
* Check the username / password against the PAM system
*/
function SYNO_IMPORT_USER($username, $password ){
  global $c;

  $client_ip = escapeshellarg($_SERVER['REMOTE_ADDR']);

  $script = '/var/packages/Calendar/target/tool/synocalendar';
  $cmd = sprintf( 'user=%s pass=%s client_ip=%s %s --auth-import', escapeshellarg($username), escapeshellarg($password), $client_ip, $script);
  $auth_result = exec($cmd, $output, $rv);
  if($rv == 0) {
      exec('/usr/syno/bin/synoautoblock --deny ' . $client_ip, $output, $rv);
      if ($rv == 1) { //denied ip
        dbg_error_log( "LOG ", "This IP(%s) is denied.", $client_ip);
        return false;
      }
	  //syslog(LOG_ERR, "syno_import_user, return true");
	  //syslog(LOG_ERR, "out=" . print_r($output, true));
	  //print convert user name, ex: ldapa => ldapa@a.b.c
      exec('/usr/syno/bin/synoautoblock --reset ' . $client_ip);
	  return $output[0];
  }

  exec('/usr/syno/bin/synoautoblock --attempt ' . $client_ip);
  syslog(LOG_ERR, "syno_import_user, return false");
  return false;
}
